<template>
  <div class="wrapper">
    <div class="section page-header header-filter" :style="headerStyle">
      <div class="container" style="max-height: 720px">
        <div class="md-layout md-gutter md-alignment-center-center">
          <modal v-if="sending">
            <template slot="header"> </template>

            <template slot="body">
              <img
                class="md-title rounded"
                :src="logo"
                alt="logo-upj"
                style="height: 60px;"
              />
              <br />
              <md-progress-spinner
                :md-diameter="40"
                :md-stroke="4"
                md-mode="indeterminate"
              />
            </template>

            <template slot="footer"> </template>
          </modal>
          <form
            ref="form"
            novalidate
            class="md-layout"
            @submit.prevent="onSubmit"
          >
            <md-card
              class="md-layout-item md-size-40 md-small-size-100 mx-auto"
              style="padding-bottom: 20px; top: -120px"
            >
              <md-card-header>
                <img
                  class="md-title rounded"
                  :src="logo"
                  alt="logo-upj"
                  style="height: 60px; width: 60px; margin: 15px 10px 0px 0px"
                />
                <div class="md-title">
                  <h2 style="letter-spacing: 2px;color: green;margin-top:30px;">
                    <strong>Dashboard KOTA</strong>
                  </h2>
                  <p
                    style="letter-spacing: 2px;font-size: 24px;color: green;margin-top:0px; padding: 0px 0px 20px 2px"
                  >
                    Universitas Pembangunan Jaya
                  </p>
                </div>
              </md-card-header>

              <md-card-content>
                <div class="md-layout md-gutter">
                  <md-field :class="getValidationClass('username')">
                    <md-icon>person</md-icon>
                    <label for="username">Username</label>
                    <md-input
                      name="username"
                      id="username"
                      autocomplete="username"
                      v-model="usersData.username"
                      :disabled="sending"
                    />
                    <span
                      class="md-error"
                      v-if="!$v.usersData.username.required"
                      >The username is required</span
                    >
                    <span
                      class="md-error"
                      v-else-if="!$v.usersData.username.minlength"
                      >Invalid username</span
                    >
                  </md-field>
                </div>
                <br />
                <div class="md-layout md-gutter">
                  <md-field :class="getValidationClass('password')">
                    <md-icon>lock_outline</md-icon>

                    <label for="password">Password</label>
                    <md-input
                      type="password"
                      name="password"
                      id="password"
                      autocomplete="password"
                      v-model="usersData.password"
                      :disabled="sending"
                    />
                    <span
                      class="md-error"
                      v-if="!$v.usersData.password.required"
                      >The password is required</span
                    >
                    <span
                      class="md-error"
                      v-else-if="!$v.usersData.password.password"
                      >Invalid password</span
                    >
                  </md-field>
                </div>
              </md-card-content>

              <md-card-actions>
                <md-button
                  type="submit"
                  class="md-login md-success md-lg md-round"
                  :disabled="sending"
                  style="height: 50px; width: 100%;"
                  ><span
                    style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
                  >
                    Login
                  </span></md-button
                >
              </md-card-actions>
              <div
                style="padding-top: 25px; padding-bottom: 10px"
                class="container mx-auto"
              >
                <h4 style="font-size: 14px" class="mx-auto">
                  Untuk informasi lebih lanjut silahkan hubungi
                </h4>
                <span style="font-size: 15px;" class="mx-auto">
                  <!-- <i class="fa fa-at"></i> -->
                  <img
                    class="rounded"
                    :src="outlook"
                    alt="logo-upj"
                    style="width: 20px; margin: 0px 2px"
                  />
                  lse@upj.ac.id
                </span>
                <!-- <span style="font-size: 14px" 
                  >Jangan lupa ikuti media sosial LSE UPJ</span
                > -->

                <span style="font-size: 15px;" class="mx-auto">
                  <a href="https://www.instagram.com/lse.upj/">
                    <img
                      class="rounded"
                      :src="instagram"
                      alt="logo-upj"
                      style="width: 25px; margin: 10px 0px 0px 0px"
                    />
                  </a>
                  <a
                    href="https://www.youtube.com/channel/UC3UY7HbpLpphdT6OQrQN3xA"
                  >
                    <img
                      class="rounded"
                      :src="youtube"
                      alt="logo-upj"
                      style="width: 25px; margin: 10px 0px 0px 10px"
                    />
                  </a>
                  <!-- <i class="fab fa-instagram"></i>
                  <a href="https://www.instagram.com/lse.upj/"> lse.upj </a>
                  <i class="fab fa-youtube" style="margin-left: 20px"></i>
                  <a
                    href="https://www.youtube.com/channel/UC3UY7HbpLpphdT6OQrQN3xA"
                  >
                    LSE UPJ
                  </a> -->
                </span>
              </div>

              <!-- <div class="container mx-auto" style="padding-top: 15px">
                <p class="mx-auto" style="font-size: 15px">
                  Belum memiliki akun?
                  <router-link
                    style="color: green; font-size: 17px; padding-left: 2px"
                    :to="{
                      name: 'register'
                    }"
                  >
                    Buat Akun
                  </router-link>
                </p>
              </div> -->

              <!-- <md-progress-bar md-mode="indeterminate" v-if="sending" /> -->
            </md-card>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";
import { Modal } from "@/components";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  components: { Modal },
  bodyClass: "login-page",
  data: () => ({
    classicModal: false,
    showSnackbar: false,
    position: "center",
    duration: 4000,
    isInfinity: false,
    form: {
      username: null,
      password: null
    },
    userSaved: false,
    sending: false
  }),
  validations: {
    usersData: {
      username: {
        required,
        minLength: minLength(3)
      },
      password: {
        required,
        minLength: minLength(5)
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    },
    instagram: {
      type: String,
      default: require("@/assets/img/logo/instagram.png")
    },
    youtube: {
      type: String,
      default: require("@/assets/img/logo/youtube.png")
    },
    outlook: {
      type: String,
      default: require("@/assets/img/logo/outlook.jpg")
    }
  },
  methods: {
    async onSubmit() {
      this.$v.$touch();
      this.sending = true;
      this.classicModal = true;
      if (!this.$v.invalid) {
        // if (this.$refs.form.submit()) {
        try {
          await this.$store.dispatch("login", this.usersData);
          this.sending = false;
          this.$router.push("/dashboard");
        } catch (error) {
          this.sending = false;
          throw Error(error);
        }
      }
    },
    getValidationClass(fieldName) {
      const field = this.$v.usersData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    clearForm() {
      this.$v.$reset();
      this.form.username = null;
      this.form.password = null;
    }
    // saveUser() {
    //   this.sending = true;
    //   window.setTimeout(() => {
    //     this.userSaved = true;
    //     this.sending = false;
    //     this.clearForm();
    //   }, 1500);
    // },
    // validateUser() {
    //   this.$v.$touch();

    //   if (!this.$v.$invalid) {
    //     this.saveUser();
    //   }
    // }
  },
  computed: {
    ...mapState({
      errors: state => state.auth.errors
    }),
    ...mapState("user", ["usersData"]),
    ...mapState(["auth"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    },
    messageClass() {
      return {
        "md-invalid": this.hasMessages
      };
    }
  }
};
</script>

<style lang="scss" scoped>
.md-progress-bar {
  margin: 24px;
}

.md-progress-spinner {
  margin: 24px;
}
</style>
